// Source file for the matrix conversion to ascii text

#include <stdlib.h>
#include <stdio.h>



int 
main(int argc, char **argv)
{
  // Check arguments
  if (argc != 4) {
    fprintf(stderr, "Usage: mat2txt matrixfile textfile nrows\n");
    exit(-1);
  }

  // Parse number of rows
  int n = atoi(argv[3]);

  // Allocate matrix
  float *matrix = new float [ n*n ];
  if (!matrix) { 
    fprintf(stderr, "Unable to allocate matrix\n"); 
    exit(-1); 
  }

  // Open matrix file
  FILE *fp1 = fopen(argv[1], "rb");
  if (!fp1) { 
    fprintf(stderr, "Unable to open matrix file %s\n", argv[1]); 
    exit(-1); 
  }

  // Read matrix file
  if (fread(matrix, sizeof(float), n*n, fp1) != (unsigned int) n*n) { 
    fprintf(stderr, "Unable to read matrix file %s\n", argv[1]); 
    exit(-1); 
  }

  // Close matrix file
  fclose(fp1);

  // Open text file
  FILE *fp2 = fopen(argv[2], "w");
  if (!fp2) { 
    fprintf(stderr, "Unable to open text file %s\n", argv[2]); 
    exit(-1); 
  }

  // Write text file
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      fprintf(fp2, "%8g ", matrix[i*n+j]);
    }
    fprintf(fp2, "\n");
  }

  // Close text file
  fclose(fp2);

  // Deallocate matrix
  delete [] matrix;

  // Return success
  return 0;
}
