// Include file for a heap

#ifndef __RN__HEAP__H__
#define __RN__HEAP__H__



// Class definition 

template <class PtrType>
class RNHeap {
  public:
    // Constructor functions
    RNHeap(int value_offset, int entry_offset = -1, int least_first = TRUE);
    ~RNHeap(void); 

    // Data access functions
    int IsEmpty(void) const;
    int NEntries(void) const;
    PtrType Kth(int k) const;
    PtrType operator[](int k) const;
    PtrType Peak(void) const;

    // Manipulation functions
    void Empty(void);
    void Update(PtrType data);
    void Push(PtrType data);
    PtrType Pop(void);

  protected:
    // Update functions
    int BubbleUp(int i);
    int BubbleDown(int i);
    void Swap(int i, int j);

    // Debug functions
    int IsValid(void);

  private:
    PtrType *entries;
    int nentries;
    int nallocated;
    int value_offset;
    int entry_offset;
    int least_first;
    void *appl;
};



// Include files

#include "RNHeap.C"



#endif
